package com.roshka.bootcamp;

import jakarta.servlet.ServletException;
import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

@WebServlet("/consultas")
public class ConsultaClienteFactura extends HttpServlet {

    @Override
    public void doGet(HttpServletRequest req, HttpServletResponse res) {
        String respuesta= req.getParameter("consulta");
        if(respuesta.equals("consulta1")){
            consulta1(res);
        }else if(respuesta.equals("consulta2")){
            consulta2(res);
        }
    }

    private void consulta1(HttpServletResponse res) {
        try {
            Statement stmt = BD.getConnection().createStatement();
            res.setContentType("text/html");
            PrintWriter out = res.getWriter();
            ResultSet rs = stmt
                    .executeQuery("select a.nombre, apellido, count(b.cliente_id) Cantidad_factura from cliente a " +
                            "inner join factura b " +
                            "on a.id=b.cliente_id " +
                            "group by a.nombre, a.apellido " +
                            "order by Cantidad_factura desc;");
            out.println("<html>");
            out.println("<body>");
            while (rs.next()) {
                String nombre = rs.getString("nombre");
                String apellido = rs.getString("apellido");
                int cantidad = rs.getInt("Cantidad_factura");

                out.println("<p>NOMBRE = \\" + nombre + "</p>");
                out.println("<p>APELLIDO = \\" + apellido + "</p>");
                out.println("<p>CANTIDAD FACTURA = \\" + cantidad + "</p>");

            }
            out.println("</body>");
            out.println("</html>");
            rs.close();
            stmt.close();
        } catch (Exception e) {
            System.err.println(e.getClass().getName() + ": " + e.getMessage());
        }
    }

    private void consulta2(HttpServletResponse res) {
        try {
            Statement stmt = BD.getConnection().createStatement();
            res.setContentType("text/html");
            PrintWriter out = res.getWriter();
            ResultSet rs = stmt
                    .executeQuery( "select b.nombre, count(moneda_id) Cantidad  from factura a\n" +
                            "inner join moneda b\n" +
                            "on b.id=a.moneda_id\n" +
                            "group by b.nombre, a.moneda_id\n" +
                            "order by cantidad desc" );
            out.println("<html>");
            out.println("<body>");
            out.print("<b>Moneda " + "- " + "Cantidad</b><hr>");
            while (rs.next()) {
                String nombre = rs.getString("nombre");
                String cantidad = rs.getString("Cantidad");
                out.print("<h5>" + nombre + " = \t"+cantidad+"</h5>");

            }
            out.println("</body>");
            out.println("</html>");
            rs.close();
            stmt.close();
        } catch (Exception e) {
            System.err.println(e.getClass().getName() + ": " + e.getMessage());
        }
    }

    public void destroy() {
        try {
            BD.getConnection().close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
